From 83c69e92f73940237caa70572903b836943ef312 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:19 +0000
Subject: [PATCH 459/2232] Test Rust Vec in Rust signatures


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 2c8cc87..be58cbd 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -427,9 +427,11 @@ fn expand_rust_function_shim_impl(
                 quote!(::std::mem::take((*#ident).as_mut_string()))
             }
             Type::RustBox(_) => quote!(::std::boxed::Box::from_raw(#ident)),
+            Type::RustVec(_) => quote!(::std::mem::take((*#ident).as_mut_vec())),
             Type::UniquePtr(_) => quote!(::cxx::UniquePtr::from_raw(#ident)),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(i) if i == RustString => quote!(#ident.as_string()),
+                Type::RustVec(_) => quote!(#ident.as_vec()),
                 _ => quote!(#ident),
             },
             Type::Str(_) => quote!(#ident.as_str()),
@@ -460,11 +462,13 @@ fn expand_rust_function_shim_impl(
                 Some(quote!(::cxx::private::RustString::from(#call)))
             }
             Type::RustBox(_) => Some(quote!(::std::boxed::Box::into_raw(#call))),
+            Type::RustVec(_) => Some(quote!(::cxx::private::RustVec::from(#call))),
             Type::UniquePtr(_) => Some(quote!(::cxx::UniquePtr::into_raw(#call))),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(ident) if ident == RustString => {
                     Some(quote!(::cxx::private::RustString::from_ref(#call)))
                 }
+                Type::RustVec(_) => Some(quote!(::cxx::private::RustVec::from_ref(#call))),
                 _ => None,
             },
             Type::Str(_) => Some(quote!(::cxx::private::RustStr::from(#call))),
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index fca9808..d2c860e 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -84,6 +84,8 @@ pub mod ffi {
         fn r_return_str(shared: &Shared) -> &str;
         fn r_return_rust_string() -> String;
         fn r_return_unique_ptr_string() -> UniquePtr<CxxString>;
+        fn r_return_rust_vec() -> Vec<u8>;
+        fn r_return_ref_rust_vec(shared: &Shared) -> &Vec<u8>;
 
         fn r_take_primitive(n: usize);
         fn r_take_shared(shared: Shared);
@@ -95,6 +97,8 @@ pub mod ffi {
         fn r_take_sliceu8(s: &[u8]);
         fn r_take_rust_string(s: String);
         fn r_take_unique_ptr_string(s: UniquePtr<CxxString>);
+        fn r_take_rust_vec(v: Vec<u8>);
+        fn r_take_ref_rust_vec(v: &Vec<u8>);
 
         fn r_try_return_void() -> Result<()>;
         fn r_try_return_primitive() -> Result<usize>;
@@ -171,6 +175,15 @@ fn r_return_unique_ptr_string() -> UniquePtr<CxxString> {
     unsafe { UniquePtr::from_raw(cxx_test_suite_get_unique_ptr_string()) }
 }
 
+fn r_return_rust_vec() -> Vec<u8> {
+    Vec::new()
+}
+
+fn r_return_ref_rust_vec(shared: &ffi::Shared) -> &Vec<u8> {
+    let _ = shared;
+    unimplemented!()
+}
+
 fn r_take_primitive(n: usize) {
     assert_eq!(n, 2020);
 }
@@ -212,6 +225,14 @@ fn r_take_unique_ptr_string(s: UniquePtr<CxxString>) {
     assert_eq!(s.as_ref().unwrap().to_str().unwrap(), "2020");
 }
 
+fn r_take_rust_vec(v: Vec<u8>) {
+    let _ = v;
+}
+
+fn r_take_ref_rust_vec(v: &Vec<u8>) {
+    let _ = v;
+}
+
 fn r_try_return_void() -> Result<(), Error> {
     Ok(())
 }

